function[X_loc,F_loc,G_loc] = run_subea(x,surr,param,prob,rangesurr)
% Initialization
xpop = repmat(rangesurr(:,1)',param.subea_pop_size-1,1)+(repmat(rangesurr(:,2)',param.subea_pop_size-1,1)-repmat(rangesurr(:,1)',param.subea_pop_size-1,1)).*(lhsdesign(param.subea_pop_size-1,prob.nx));
X_pop = [x;xpop];
for i = 1:size(X_pop,1)
    F_pop(i,:) = pred_obj(X_pop(i,:),surr);
    [G_pop(i,:),~] = pred_constr(X_pop(i,:),surr);
end
% Sort initialization
if param.subea_type == 1
    [X_pop, F_pop, G_pop]=sort_pop(X_pop, F_pop, G_pop);
else
    f_new = new_objective(G_pop, param, prob);
    [X_pop, F_pop, G_pop] = sort_idea(X_pop, F_pop, G_pop, param, f_new);
end
for i = 1:param.subea_generations
    [parent_idx]=min(1:param.subea_pop_size,randperm(param.subea_pop_size));
    [X_child] = genetic_operator(rangesurr(:,1)',rangesurr(:,2)',param,prob,X_pop(parent_idx,:));
    for j = 1:size(X_pop,1)
        F_child(j,:) = pred_obj(X_child(j,:),surr);
        [G_child(j,:),~] = pred_constr(X_child(j,:),surr);
    end
    X_pop=[X_pop;X_child];F_pop=[F_pop;F_child];G_pop=[G_pop;G_child];
    if param.subea_type == 1
        [X_pop, F_pop, G_pop]=sort_pop(X_pop, F_pop, G_pop);
    else
        f_new = new_objective(G_pop, param, prob);
        [X_pop, F_pop, G_pop] = sort_idea(X_pop, F_pop, G_pop, param, f_new);
    end
    X_pop=X_pop(1:param.subea_pop_size,:);
    F_pop=F_pop(1:param.subea_pop_size,:);
    if(~isempty(G_pop))
        G_pop=G_pop(1:param.subea_pop_size,:);
        CVpop = sum(max(G_pop,0),2);
    else
        G_pop=[];
        CVpop = zeros(param.subea_pop_size,1);
    end
end
[rankbest]=sort_best(F_pop,CVpop);
X_loc = X_pop(rankbest(1),:);
F_loc = F_pop(rankbest(1),:);
G_loc = G_pop(rankbest(1),:);
end