function [f,g] = MaF2(objnum,x)
if nargin <= 1
    prob.nf = objnum;
    prob.ng = 0;
    prob.nx = 3*prob.nf;
    prob.cast = [];
    for i = 1:prob.nx
        prob.range(i,:) = [0,1];
    end
    f = prob;
    g = [];
else
    [f,g] = MaF2_true(x,objnum);
end
return

function [f,gg] = MaF2_true(PopDec,objnum)
[N,D] = size(PopDec);
M     = objnum;
g     = zeros(N,M);
for m = 1 : M
    if m < M
        g(:,m) = sum(((PopDec(:,M+(m-1)*floor((D-M+1)/M):M+m*floor((D-M+1)/M)-1)/2+1/4)-0.5).^2,2);
    else
        g(:,m) = sum(((PopDec(:,M+(M-1)*floor((D-M+1)/M):D)/2+1/4)-0.5).^2,2);
    end
end
f = (1+g).*fliplr(cumprod([ones(size(g,1),1),cos((PopDec(:,1:M-1)/2+1/4)*pi/2)],2)).*[ones(size(g,1),1),sin((PopDec(:,M-1:-1:1)/2+1/4)*pi/2)];
gg = [];
return