function [f,g] = MaF4(objnum,x)
if nargin <= 1
    prob.nf = objnum;
    prob.ng = 0;
    prob.nx = 3*prob.nf;
    prob.cast = [];
    for i = 1:prob.nx
        prob.range(i,:) = [0,1];
    end
    f = prob;
    g = [];
else
    [f,g] = MaF4_true(x,objnum);
end
return

function [f,gg] = MaF4_true(PopDec,objnum)
[N,D]  = size(PopDec);
M      = objnum;
g      = 100*(D-M+1+sum((PopDec(:,M:end)-0.5).^2-cos(20.*pi.*(PopDec(:,M:end)-0.5)),2));
PopObj = repmat(1+g,1,M) - repmat(1+g,1,M).*fliplr(cumprod([ones(N,1),cos(PopDec(:,1:M-1)*pi/2)],2)).*[ones(N,1),sin(PopDec(:,M-1:-1:1)*pi/2)];
f = PopObj.*repmat(2.^(1:M),N,1);
gg = [];
return