function [f,g] = MaF5(objnum,x)
if nargin <= 1
    prob.nf = objnum;
    prob.ng = 0;
    prob.nx = 3*prob.nf;
    prob.cast = [];
    for i = 1:prob.nx
        prob.range(i,:) = [0,1];
    end
    f = prob;
    g = [];
else
    [f,g] = MaF5_true(x,objnum);
end
return

function [f,gg] = MaF5_true(PopDec,objnum)
M      = objnum;
PopDec(:,1:M-1) = PopDec(:,1:M-1).^100;
g      = sum((PopDec(:,M:end)-0.5).^2,2);
PopObj = repmat(1+g,1,M).*fliplr(cumprod([ones(size(g,1),1),cos(PopDec(:,1:M-1)*pi/2)],2)).*[ones(size(g,1),1),sin(PopDec(:,M-1:-1:1)*pi/2)];
f = PopObj.*repmat(2.^(M:-1:1),size(g,1),1);
gg = [];
return