function [f,g] = MaF6(objnum,x)
if nargin <= 1
    prob.nf = objnum;
    prob.ng = 0;
    prob.nx = 3*prob.nf;
    prob.cast = [];
    for i = 1:prob.nx
        prob.range(i,:) = [0,1];
    end
    f = prob;
    g = [];
else
    [f,g] = MaF6_true(x,objnum);
end
return

function [f,gg] = MaF6_true(PopDec,objnum)
I      = 2;
M      = objnum;
g      = sum((PopDec(:,M:end)-0.5).^2,2);
Temp   = repmat(g,1,M-I);
PopDec(:,I:M-1) = (1+2*Temp.*PopDec(:,I:M-1))./(2+2*Temp);
f = repmat(1+100*g,1,M).*fliplr(cumprod([ones(size(g,1),1),cos(PopDec(:,1:M-1)*pi/2)],2)).*[ones(size(g,1),1),sin(PopDec(:,M-1:-1:1)*pi/2)];
gg = [];
return