function [f,g] = UF2(objnum,x)
if nargin <= 1
	prob.nf = objnum;
	prob.ng = 0;
	prob.nx = 3;
    for i = 1:prob.nx
        if i == 1
            prob.range(i,:) = [0,1];
        else            
            prob.range(i,:) = [-1,1];
        end
    end

	f = prob;
    g = [];
else
	[f,g] = UF2_true(x,objnum);
end
return

function [f,g] = UF2_true(x,objnum)
D = size(x,2);

J1 = 3 : 2 : D;
J2 = 2 : 2 : D;
Y       = zeros(size(x));
x1      = repmat(x(:,1),1,length(J1));
Y(:,J1) = x(:,J1)-(0.3*x1.^2.*cos(24*pi*x1+4*repmat(J1,size(x,1),1)*pi/D)+0.6*x1).*cos(6*pi*x1+repmat(J1,size(x,1),1)*pi/D);
x1      = repmat(x(:,1),1,length(J2));
Y(:,J2) = x(:,J2)-(0.3*x1.^2.*cos(24*pi*x1+4*repmat(J2,size(x,1),1)*pi/D)+0.6*x1).*sin(6*pi*x1+repmat(J2,size(x,1),1)*pi/D);
f(:,1) = x(:,1)         + 2*mean(Y(:,J1).^2,2);
f(:,2) = 1-sqrt(x(:,1)) + 2*mean(Y(:,J2).^2,2);

g = [];
return