function [f,g] = UF3_a(objnum,x)
if nargin <= 1
	prob.nf = objnum;
	prob.ng = 0;
	prob.nx = 3;    
    for i = 1:prob.nx
            prob.range(i,:) = [0,1];
    end

	f = prob;
    g = [];
else
	[f,g] = UF3_a_true(x,objnum);
end
return

function [f,g] = UF3_a_true(x,objnum)
D = size(x,2);

J1 = 3 : 2 : D;
J2 = 2 : 2 : D;
Y  = x - repmat(x(:,1),1,D).^(0.5*(1+3*(repmat(1:D,size(x,1),1)-2)/(D-2)));
f(:,1) = x(:,1)         + 2/length(J1)*(4*sum(Y(:,J1).^2,2)-2*prod(cos(2*Y(:,J1)*pi./sqrt(repmat(J1,size(x,1),1))),2)+2);
f(:,2) = 1-sqrt(x(:,1)) + 2/length(J2)*(4*sum(Y(:,J2).^2,2)-2*prod(cos(2*Y(:,J2)*pi./sqrt(repmat(J2,size(x,1),1))),2)+2);
g = [];
return