function [f,g] = UF4(objnum,x)
if nargin <= 1
	prob.nf = objnum;
	prob.ng = 0;
	prob.nx = 3;
    for i = 1:prob.nx
        if i == 1
            prob.range(i,:) = [0,1];
        else            
            prob.range(i,:) = [-2,2];
        end
    end

	f = prob;
    g = [];
else
	[f,g] = UF4_true(x,objnum);
end
return

function [f,g] = UF4_true(x,objnum)
D = size(x,2);

J1 = 3 : 2 : D;
J2 = 2 : 2 : D;
Y  = x - sin(6*pi*repmat(x(:,1),1,D)+repmat(1:D,size(x,1),1)*pi/D);
hY = abs(Y)./(1+exp(2*abs(Y)));
f(:,1) = x(:,1)      + 2*mean(hY(:,J1),2);
f(:,2) = 1-x(:,1).^2 + 2*mean(hY(:,J2),2);



g = [];
return