function [f,g] = UF6_a(objnum,x)
if nargin <= 1
	prob.nf = objnum;
	prob.ng = 0;
	prob.nx = 3;
    for i = 1:prob.nx
        if i == 1
            prob.range(i,:) = [0,1];
        else            
            prob.range(i,:) = [-1,1];
        end
    end

	f = prob;
    g = [];
else
	[f,g] = UF6_a_true(x,objnum);
end
return

function [f,g] = UF6_a_true(x,objnum)
D = size(x,2);

J1 = 3 : 2 : D;
J2 = 2 : 2 : D;
Y  = x - sin(6*pi*repmat(x(:,1),1,D)+repmat(1:D,size(x,1),1)*pi/D);
f(:,1) = x(:,1)   + max(0,2*(1/4+0.1)*sin(4*pi*x(:,1)))+2/length(J1)*(4*sum(Y(:,J1).^2,2)-2*prod(cos(2*Y(:,J1)*pi./sqrt(repmat(J1,size(x,1),1))),2)+2);
f(:,2) = 1-x(:,1) + max(0,2*(1/4+0.1)*sin(4*pi*x(:,1)))+2/length(J2)*(4*sum(Y(:,J2).^2,2)-2*prod(cos(2*Y(:,J2)*pi./sqrt(repmat(J2,size(x,1),1))),2)+2);


g = [];
return